/*
    Copyright (C) 2013 Nicola L.C. Talbot
    www.dickimaw-books.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
package com.dickimawbooks.makejmlrbookgui;

import java.net.*;
import java.nio.file.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class WelcomeDialog extends JDialog implements ActionListener
{
   public WelcomeDialog(MakeJmlrBookGUI app)
   {
      super(app, app.getLabel("welcome.title"));

      Path cimlSample = null;
      Path wcpSample = null;

      try
      {
         URL url = getClass().getResource("/resources/");

         if (url != null)
         {
            URI uri = url.toURI();

            if (uri != null)
            {
               URI sample = uri.resolve("../../sample-books/sample-ciml-book/sample-ciml-book.tex");

               cimlSample = Paths.get(sample);

               sample = uri.resolve("../../sample-books/sample-wcp/sample-wcp.tex");

               wcpSample = Paths.get(sample);
            }
         }
      }
      catch (NullPointerException e)
      {
      }
      catch (URISyntaxException e)
      {
         app.debug(e);
      }


      JEditorPane info = new JEditorPane("text/html", app.getLabelWithValues("welcome.text",
         new String[] {app.appName, app.appVersion,
          app.getLabel("file")+"->"+app.getLabel("file.open"),
          wcpSample.toString(), cimlSample.toString(),
          app.getLabel("file")+"->"+app.getLabel("file.new")}));
      info.setEditable(false);

      getContentPane().add(new JScrollPane(info), "Center");

      JPanel buttonPanel = new JPanel();
      getContentPane().add(buttonPanel, "South");

      buttonPanel.add(JMLRResources.createCloseButton(this));

      Toolkit tk = Toolkit.getDefaultToolkit();
      Dimension d = tk.getScreenSize();
      setSize(d.width/2, d.height/2);

      setLocationRelativeTo(app);
   }

   public void actionPerformed(ActionEvent evt)
   {
      String action = evt.getActionCommand();

      if (action == null) return;

      if (action.equals("close"))
      {
         setVisible(false);
      }
   }
}
