/*
    Copyright (C) 2013 Nicola L.C. Talbot
    www.dickimaw-books.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
package com.dickimawbooks.makejmlrbookgui.newbook;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;

import com.dickimawbooks.texparserlib.bib.Contributor;

import com.dickimawbooks.makejmlrbookgui.*;

public class TitleSpinnerField extends JPanel implements TitleField
{
   public TitleSpinnerField(String parentTag, String tag, 
     TitleSpinnerFieldInfo info)
   {
      super(new FlowLayout(FlowLayout.LEADING, 5, 0));
      setAlignmentX(LEFT_ALIGNMENT);

      field = info.createSpinner();
      add(field);

      String label = parentTag+"."+tag;

      jLabel = new JLabel(MakeJmlrBookGUI.getLabel(label));
      jLabel.setDisplayedMnemonic(MakeJmlrBookGUI.getMnemonic(label));
      jLabel.setLabelFor(field);

      String tooltip = MakeJmlrBookGUI.getLabelWithAlt(label+".tooltip", null);

      if (tooltip != null)
      {
         field.setToolTipText(tooltip);
         jLabel.setToolTipText(tooltip);
      }

      Dimension dim = getMaximumSize();
      dim.height = (int)getPreferredSize().getHeight();
      setMaximumSize(dim);
   }

   public JComponent getComponent()
   {
      return this;
   }

   public JComponent getLabel()
   {
      return jLabel;
   }

   public String getText()
   {
      return field.getValue().toString();
   }

   public int getNumValues()
   {
      return 1;
   }

   public boolean isEmpty()
   {
      return getText().isEmpty();
   }

   public int getIntValue()
   {
      return ((Number)field.getValue()).intValue();
   }

   public void setFieldValue(Object object)
   {
      field.setValue(object);
   }

   public Vector<String> getList()
   {
      Vector<String> list = new Vector<String>(1);
      list.add(getText());

      return list;
   }

   public Vector<Contributor> getContributors()
   {
      return null;
   }

   private JSpinner field;
   private JLabel jLabel;
}

